var doc = app.activeDocument;
var obj = doc.selection;
var mLayer= doc.activeLayer;
var newItem;
var i, sourceDoc, targetFile;
var destFolder = null;
var docSelected = doc.selection;
var mem = new Array();
var cropOLD = new Array();
var errorIcon = true;
var strSaveDialog = "Select path to save file";
var prefStr = "Preference: Resolution; ColorSpace(CMYK,Grayscale,RGB); AntiAliasing(1,0); EmbedICCProfile(1,0); EditableText(1,0); MaximumEditability(1,0); WriteLayers(1,0); Warnings(1,0)";
var pref = "150;RGB;1;1;0;0;0;0";
var opt = new ExportOptionsPhotoshop();
var type = ExportType.PHOTOSHOP;
	opt.antiAliasing = true;	
	opt.resolution = 150;
	opt.embedICCProfile = true;
	opt.editableText = false;	
	opt.maximumEditability = false;
	opt.warnings = false;
	opt.writeLayers = false;
// CMYK Grayscale RGB
	opt.imageColorSpace = ImageColorSpace.RGB;

var optJPEG = new ExportOptionsJPEG();
var typeJPEG = ExportType.JPEG;
	optJPEG.antiAliasing = true;
// optimization for WEB
	optJPEG.optimization = true;
	optJPEG.qualitySetting = 100;

var PSD = true;
var start = false;
var next = false;

var bnd = new Array();
if (documents.length > 0){
	if( str = prompt(prefStr,pref)){
		param = str.split(';');
		opt.resolution = param[0];		
		if ((param[1]=="CMYK")|(param[1]=="Grayscale")|(param[1]=="RGB")){
			switch(param[1]){				
				case "CMYK": opt.imageColorSpace = ImageColorSpace.CMYK; break;
				case "Grayscale": opt.imageColorSpace = ImageColorSpace.Grayscale; break;
				case "RGB": opt.imageColorSpace = ImageColorSpace.RGB; break;
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(1);
		}
		if ((param[2]==0)|(param[2]==1)){
			switch(param[2]){				
				case 0: opt.antiAliasing = false; break;
				case 1: opt.antiAliasing = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(2);
		}
		if ((param[3]==0)|(param[3]==1)){
			switch(param[2]){				
				case 0: opt.embedICCProfile = false; break;
				case 1: opt.embedICCProfile = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(3);
		}
		if ((param[4]==0)|(param[4]==1)){
			switch(param[2]){				
				case 0: opt.editableText = false; break;
				case 1: opt.editableText = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(4);
		}
		if ((param[5]==0)|(param[5]==1)){
			switch(param[2]){				
				case 0: opt.maximumEditability = false; break;
				case 1: opt.maximumEditability = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(5);
		}
		if ((param[6]==0)|(param[6]==1)){
			switch(param[2]){				
				case 0: opt.writeLayers = false; break;
				case 1: opt.writeLayers = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(6);
		}
		if ((param[7]==0)|(param[7]==1)){
			switch(param[2]){				
				case 0: opt.warnings = false; break;
				case 1: opt.warnings = true; break;			
	  		}	  		
	  		next = true;
		}
		else {
			next = errorMes(7);
		}
		
	}
	else next = false;
	if (next){
	if (obj.length > 0) {
		bnd = getBounds(obj);	
		W = bnd[2] - bnd[0];
		H = bnd[1] - bnd[3];
		X = bnd[0];
		Y = bnd[1];
		start = true;
	}
	else {
		doc.rulerOrigin = Array(0, 0);
		bnd[0] = 0;
		bnd[2] = doc.width;
		bnd[1] = doc.height;
		bnd[3] = 0;		
	}
	cropOLD = doc.cropBox;
	doc.cropBox = bnd;
	doc.cropStyle = CropOptions.Standard;
	if (start) {
		var j=0;
		for (i=0; i<doc.layers.length; i++) {
			if (doc.layers[i].visible){
				doc.layers[i].visible = false;
			}
			else {
				mem[j] = i;
				j = j + 1;
			}
		}		
		var mLayer= doc.layers.add();
		mLayer.zOrder(ZOrderMethod.SENDTOBACK);
		for (j=0; j < docSelected.length; j++) newItem = docSelected[j].duplicate(doc, ElementPlacement.PLACEATEND);
	}		
	var destFolder = File.saveDialog(strSaveDialog,'/d/');
	if (destFolder != null) {	
		targetFile = destFolder;
		if (PSD) doc.exportFile(targetFile, type, opt);
		else doc.exportFile(targetFile, typeJPEG, optJPEG);
	}
	doc.cropBox = cropOLD;
	if (start) {
		mLayer.remove();
		j=0;	
		for (i=0; i<doc.layers.length; i++) {		
			doc.layers[i].visible = true;
		}
		for (i=0; i<mem.length; i++) {
			j = mem[i];
			doc.layers[j].visible = false;
		}
	}
	}		
}
function errorMes(i){
	var er = false;
	var errorStr = 'Wrong parameter: '+param[i];
	alert(errorStr,'ScriptError',errorIcon);	
	return er;
}

function getBounds(obj) {
	var selObj1 = new Array();
	var selObj2 = new Array();
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ){
			clipObj = obj[0].pathItems[0].geometricBounds;
			vgb1 = clipObj;
		}
		else {
			selObj1 = obj[0];
			vgb1 = selObj1.visibleBounds;
		}
		if (n > 1) {
			for (i=1; i<n; i++) {
				selObj2 = obj[i];
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = selObj2.visibleBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}
